;=============================================================================
; 	 - Nokia5110 (Nokia3310)    PCD8544
;	   :   
;-----------------------------------------------------------------------------
;  : R0, R6, R16, R17, R18, ZL, ZH
;=============================================================================
	;  LCD  
	.equ LCD_DC_port  = PORTB
	.equ LCD_DC   = 1			;  - /  PORTB.1
	.equ LCD_SCE_port = PORTB
	.equ LCD_SCE  = 2			; .    PORTB.2
	.equ LCD_SDIN_port = PORTB
	.equ LCD_SDIN = 3			;   PORTB.3
	.equ RES_port = PORTB
	.equ RES 	  = 4			;    PORTB.4
	.equ LCD_SCLK_port = PORTB
	.equ LCD_SCLK = 5			;   PORTB.5
	
	.include "Font_6x8a.asm" 	; 
;==============================================================================
;		    LCD
;------------------------------------------------------------------------------
lcd_init_tab: 
		.db 0x21, 0xC6, 0x06, 0x13, 0x20, 0x0C
		; 0x21 ; (PD=0, V=0, H=1) . ; .  
		; 0xBC ;  (Vop) 0xC8 - !  (0xBC)
		; 0x06 ;   (Temp coefficent)
		; 0x13 ;  (LCD bias mode(n=4) 1:48)
		; 0x20 ; (PD=0, V=0, H=0) . ; .  
		; 0x0C ;  (D=1, E=0) 
;     0  0x7F (  080  0xFF).
; 048 ( 0xC8)  ,    0x3F ( 0xB).

;==============================================================================
;		  LCD
; !       / lcd_init,
;			    .
;----------------------------------------------------------------------------
lcd_init: 
			; 
		sbi RES_port,RES				;   RES
		DELAY 1							;  32 
		cbi LCD_SCE_port,LCD_SCE		;  (SCE=0)
		rcall Delay10us					; 10 
		
			;  LCD
		cbi RES_port,RES				;   LCD
		DELAY 1							;   32 
		sbi RES_port,RES				;   LCD
		;
		rcall Delay10us					; 10 
		sbi LCD_SCE_port,LCD_SCE		;  (SCE=0)
		DELAY 1							;  32 
		
		ldi ZL,low(lcd_init_tab*2) 		;   
		ldi ZH,high(lcd_init_tab*2) 	;
		ldi R17,6 						;-  = 6
		cbi LCD_SCE_port,LCD_SCE 		;  (SCE=0)
		cbi LCD_DC_port,LCD_DC 			; D/C =0   
		rcall lcd_loop 					; 6   LCD
		
		ret ;
;============================================================================
;		     LCD
; 	[R16 = char] -  (ASCII) 
;============================================================================
lcd_put_char:
		cpi R16,168						;    
		brne  fnt_3						;
		subi R16,(40)					;    
		rjmp fnt_1						;
fnt_3:	cpi R16,184						;    
		brne  fnt_2						;
		subi R16,(55)					;    
		rjmp fnt_1						;
		
fnt_2:	cpi R16,147						;    147
		brmi fnt_1						;    
		subi R16,160					;
		ldi ZL,low(Rus*2-32*6) 			; .  
		ldi ZH,high(Rus*2-32*6) 		;    
		rjmp chr_adr					;
		
fnt_1:	ldi ZL,low(font_tab*2-32*6) 	; .  
		ldi ZH,high(font_tab*2-32*6) 	;   
		
chr_adr:
		clr R17							;
		;  ,   6
		lsl R16 						;    2
		rol R17 						;
		add ZL,R16 						;  . 
		adc ZH,R17 						;
		lsl R16 						;    4
		rol R17 						;
		add ZL,R16 						;  . 
		adc ZH,R17 						;
		
		ldi R17,6 						;   
		clr r0 							;
		cbi LCD_SCE_port,LCD_SCE 		;  (SCE=0)
		rjmp lcd_loop 					;   LCD
		
;============================================================================
;	 N   LCD  program memory
;     LCD   
; [R17 = N] -  
; [Z = ] -     FLASH   SRAM
;----------------------------------------------------------------------------
lcd_send:
		cbi LCD_SCE_port,LCD_SCE 		;  (SCE=0)
lcd_loop: 
		lpm 							;  
		adiw ZL,1 						;  
lcd_send1: 
		ldi R18,8 						;   
lcd_loop1: 
		cli
		cbi LCD_SCLK_port,LCD_SCLK 		;  SCLK
		nop								; 
		nop								; 
		nop								; 
		nop								; 
		sbrc r0,7 						;  
		sbi LCD_SDIN_port,LCD_SDIN 		;  
		sbrs r0,7 						;   
		cbi LCD_SDIN_port,LCD_SDIN 		;  SDIN
		lsl r0 							;  ( )
		
		rcall Delay10us					;  
		
		sbi LCD_SCLK_port,LCD_SCLK 		;  SCLK
		rcall Delay10us					;  
		
		dec R18 						;    , -
		brne lcd_loop1 					;    . 
		
		cbi LCD_SDIN_port,LCD_SDIN 		;  
		cbi LCD_SCLK_port,LCD_SCLK 		;  SCLK
		rcall Delay10us					;   
		
		dec R17 						;    , -
		brne lcd_loop 					;    . 
		sbi LCD_SCE_port,LCD_SCE 		;  (SCE=1)
		sbi LCD_DC_port,LCD_DC 			; D/C =1   
		
		sei
		ret 							; 
;============================================================================
;		     ( )
; :   R16 = X    0...13
;----------------------------------------------------------------------------
lcd_X: 	
		ldi R18,6           			;    
		muls R16,R18           			;   
 		mov R18,R0						;   R0
		ori R18,0x80 					;
		
		mov r0,R18 						;   
		ldi R17,1 						;  1 
		cbi LCD_SCE_port,LCD_SCE		;  (SCE=0)
		cbi LCD_DC_port,LCD_DC 			; D/C =0   
		
		rjmp lcd_send1 					; 
		
;============================================================================
;		     ( )
; :   R16 = X    0...13
;----------------------------------------------------------------------------
lcd_XClk: 	
		ldi R18,5           			;    
		muls R16,R18           			;   
 		mov R18,R0						;   R0
		ori R18,0x80 					;
		
		mov r0,R18 						;   
		ldi R17,1 						;  1 
		cbi LCD_SCE_port,LCD_SCE		;  (SCE=0)
		cbi LCD_DC_port,LCD_DC 			; D/C =0   
		
		rjmp lcd_send1 					; 
;=============================================================================
;		    ( Y)
; :   R16 = Y    0...5
;-----------------------------------------------------------------------------
lcd_Y: 	
		ori R16,0x40 					;   Y
		mov r0,R16 						;
		ldi R17,1 						;  1 
		cbi LCD_SCE_port,LCD_SCE		;  (SCE=0)
		cbi LCD_DC_port,LCD_DC 			; D/C =0   
		rjmp lcd_send1 					; 
		
;============================================================================
;		     LCD
;[ R16 = X,     1]
;----------------------------------------------------------------------------
lcd_XY: 
		sbrs R16,7 						;   =1,
		ori R16,0x40 					;     Y,
		mov r0,R16 						;      X
		ldi R17,1 						;  1 
		cbi LCD_SCE_port,LCD_SCE		;  (SCE=0)
		cbi LCD_DC_port,LCD_DC 			; D/C =0   
		
		rjmp lcd_send1 					; 
		
;============================================================================
;		  LCD
;----------------------------------------------------------------------------
lcd_clr:
		ldi R16,0x40 					;Y = 0
		rcall lcd_XY 					;
		ldi R16,0x80 					;X = 0
		rcall lcd_XY 					;
		ldi R17,84 						;   = 84
lcd_clr1:
		push R17 						; R17
		ldi R16,32 						; 
		rcall lcd_put_char 				; 
		pop R17 						; R17
		dec R17 						;  
		brne lcd_clr1 					; 
		ret
		
;=============================================================================
; 	     10 
; 		c   RCALL  RET
;-----------------------------------------------------------------------------
	Delay10us:
			PUSH R17
			LDI	R17, 23
			DEC	R17
			BRNE PC-1
			POP	R17
			RET
;==============================================================================
;		    
;         0.
; Z -   ;
;------------------------------------------------------------------------------
	Str_LCD:
		push ZL					;   
		push ZH					;  
		lpm 					;  
		tst R0					;    0,  -
		breq w_str				;  
		mov R16,R0				;
		rcall lcd_put_char		;   LCD
		pop ZH					;  
		pop ZL					;  
		adiw Z,1				;   .
		rjmp Str_LCD			;  
		
w_str:	pop ZH					;  
		pop ZL					;  
		
 		ret
		
;===============================================================================
;				      
;	temp -  (ASCII) 
;  temp1 -   , R6 - c   
;-------------------------------------------------------------------------------
 Dig_x2:
		;    
		ldi ZL,LOW((font_9x16)*2)	;  1-  
		ldi ZH,HIGH((font_9x16)*2)	; .  
		tst R16						;   0, 
		breq rec_9b					;   
ad_dg:	adiw Z,18					;   
		dec R16						;   , -
		brne ad_dg					;  . 
		;
		;  LCD  9   
rec_9b:	ldi temp1,9          		;   
		rcall lcd_send        		;  9    
		;
		;     
		mov R16,R6					;
		rcall lcd_XClk				;    
		ldi R16,2					;
		rcall lcd_Y					;  2 
		
		;  LCD  9  
		ldi temp1,9          		;   
		rcall lcd_send        		;  9    
		
		;     
		inc R6						;  
		inc R6						;    
		mov R16,R6					;
		rcall lcd_XClk				;    
		ldi R16,1					;
		rcall lcd_Y					;  2 

		ret                    		; 

;================================================================================
;				    9  16 
;	temp -  (ASCII) 
;  temp1 -   , R6 - c   
;-------------------------------------------------------------------------------
 Dig_Clk:
		;    
		ldi ZL,LOW((Font_Clock)*2)	;  1-  
		ldi ZH,HIGH((Font_Clock)*2)	; .   0
		tst R16						;   0, 
		breq rc_9b					;   
ad_dig:	adiw Z,18					;   
		dec R16						;   , -
		brne ad_dig					;  . 
		;
		;  LCD  9   
rc_9b:	ldi temp1,9          		;   
		rcall lcd_send        		;  9    
		;
		;     
		mov R16,R6					;
		rcall lcd_XClk				;    
		ldi R16,4					;
		rcall lcd_Y					;  4 
		
		;  LCD  9  
		ldi temp1,9          		;   
		rcall lcd_send        		;  9    
		
		;     
		inc R6						;  
		inc R6						;    
		mov R16,R6					;
		rcall lcd_XClk				;    
		ldi R16,3					;
		rcall lcd_Y					;  3 

		ret                    		; 

;================================================================================


	.EXIT

